if select(6, GetAddOnInfo("CowTip_" .. (debugstack():match("[C%.][o%.][w%.]Tip\\Modules\\(.-)\\") or debugstack():match("[C%.][o%.][w%.]Tip\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 45170 $"):match("%d+"))

local CowTip = CowTip
local CowTip_RaidTargetIcon = CowTip:NewModule("RaidTargetIcon", "AceEvent-2.0")
local self = CowTip_PowerBar
if CowTip.revision < VERSION then
	CowTip.version = "r" .. VERSION
	CowTip.revision = VERSION
	CowTip.date = ("$Date: 2007-07-29 04:50:47 -0400 (Sun, 29 Jul 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
CowTip.desc = "Show an icon on the toltip based on which Raid Target the unit is."

local L = CowTip:L("CowTip_RaidTargetIcon")

if GetLocale() == "zhTW" then
	L["Raid target icon"] = "團隊圖示";
	L["Change how the raid target icon shows."] = "更改顯示團隊圖示設定。";
	L["Position"] = "位置";
	L["Position of the raid target icon."] = "團隊圖示的位置。";
	L["Top-left"] = "左上";
	L["Top"] = "上";
	L["Top-right"] = "右上";
	L["Left"] = "左";
	L["Right"] = "右";
	L["Bottom-left"] = "左下";
	L["Bottom"] = "下";
	L["Bottom-right"] = "右下";
	L["Size"] = "大小";
	L["Size of the raid target icon."] = "團隊圖示的大小。";
end

local _G = _G
local GameTooltip = _G.GameTooltip
local UnitExists = _G.UnitExists
local GetRaidTargetIndex = _G.GetRaidTargetIndex
local SetRaidTargetIconTexture = _G.SetRaidTargetIconTexture

function CowTip_RaidTargetIcon:OnInitialize()
	self.db = CowTip:AcquireDBNamespace("RaidTargetIcon")
	CowTip:RegisterDefaults("RaidTargetIcon", "profile", {
		position = "TOP",
		size = 20,
	})
end

local raidTargetIcon

function CowTip_RaidTargetIcon:OnEnable()
	self:RegisterEvent("RAID_TARGET_UPDATE")
end

function CowTip_RaidTargetIcon:OnDisable()
	if raidTargetIcon then
		raidTargetIcon:Hide()
	end
end

function CowTip_RaidTargetIcon:Update()
	if not raidTargetIcon then
		raidTargetIcon = GameTooltip:CreateTexture("CowTip_RaidTargetIcon_Icon", "ARTWORK")
		raidTargetIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
		raidTargetIcon:Hide()
		raidTargetIcon:SetWidth(self.db.profile.size)
		raidTargetIcon:SetHeight(self.db.profile.size)
		self:Reposition()
	end
	if not GameTooltip:GetUnit() then
		raidTargetIcon:Hide()
		return
	end
	if not UnitExists("mouseover") then
		return
	end
	local index = GetRaidTargetIndex("mouseover")
	if index then
		SetRaidTargetIconTexture(raidTargetIcon, index)
		raidTargetIcon:Show()
	else
		raidTargetIcon:Hide()
	end
end

function CowTip_RaidTargetIcon:OnTooltipShow()
	self:Update()
end

function CowTip_RaidTargetIcon:RAID_TARGET_UPDATE()
	self:Update()
end

function CowTip_RaidTargetIcon:Reposition()
	if not raidTargetIcon then
		return
	end
	raidTargetIcon:SetPoint("CENTER", GameTooltip, self.db.profile.position)
end

function CowTip_RaidTargetIcon:SetPosition(value)
	self.db.profile.position = value
	
	self:Reposition()
end

function CowTip_RaidTargetIcon:SetSize(value)
	self.db.profile.size = value
	
	if raidTargetIcon then
		raidTargetIcon:SetWidth(value)
		raidTargetIcon:SetHeight(value)
	end
end

CowTip_RaidTargetIcon:RegisterCowTipOption({
	name = L["Raid target icon"],
	desc = L["Change how the raid target icon shows."],
	type = 'group',
	args = {
		position = {
			name = L["Position"],
			desc = L["Position of the raid target icon."],
			type = 'text',
			get = function()
				return CowTip_RaidTargetIcon.db.profile.position
			end,
			set = "SetPosition",
			validate = {
				LEFT = L["Left"],
				RIGHT = L["Right"],
				TOP = L["Top"],
				BOTTOM = L["Bottom"],
				TOPLEFT = L["Top-left"],
				TOPRIGHT = L["Top-right"],
				BOTTOMLEFT = L["Bottom-left"],
				BOTTOMRIGHT = L["Bottom-right"],
			}
		},
		size = {
			name = L["Size"],
			desc = L["Size of the raid target icon."],
			type = 'range',
			get = function()
				return CowTip_RaidTargetIcon.db.profile.size
			end,
			set = "SetSize",
			min = 5,
			max = 50,
			step = 1,
			bigStep = 5,
		}
	}
})
